package cn.net.caoyao.cpzshandset.service.presenter.impl.setting.liqueurSFY;

import java.util.ArrayList;
import java.util.List;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.widget.Toast;
import cn.net.caoyao.cpzshandset.MyHandsetApp;
import cn.net.caoyao.cpzshandset.bean.ConfigBean;
import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.HandsetSettingOption;
import cn.net.caoyao.cpzshandset.common.config.HandsetVersionConstant;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.common.util.NetWorkUtils;
import cn.net.caoyao.cpzshandset.service.bll.DealerBll;
import cn.net.caoyao.cpzshandset.service.bll.GroupInfoBll;
import cn.net.caoyao.cpzshandset.service.bll.ProductBll;
import cn.net.caoyao.cpzshandset.service.bll.UserLoginBll;
import cn.net.caoyao.cpzshandset.service.bll.config.ConfigBll;
import cn.net.caoyao.cpzshandset.service.presenter.SettingConstact;
import cn.net.caoyao.cpzshandset.service.presenter.base.impl.SettingConstactImpl;
import cn.net.caoyao.cpzshandset.service.thread.ThreadPoolManager;
import cn.net.caoyao.cpzshandset.service.thread.ThreadReqTools;
import cn.net.caoyao.cpzshandset.service.thread.impl.liqueurSFY.LiqueurSFYReqUserInfoRunable;
import cn.net.caoyao.cpzshandset.service.thread.impl.liqueurSFY.LiqueurSFYUpdateDealerListThread;
import cn.net.caoyao.cpzshandset.service.thread.impl.liqueurSFY.LiqueurSFYUpdateGroupInfoThread;
import cn.net.caoyao.cpzshandset.service.thread.impl.liqueurSFY.LiqueurSFYUpdateProductListThread;
import cn.net.caoyao.cpzshandset.ui.activity.DeviceIdConfigActivity;
import cn.net.caoyao.cpzshandset.ui.activity.ModifyHandsetVersionActivity;
import cn.net.caoyao.cpzshandset.ui.adapter.SettingAdapter;
import cn.net.caoyao.cpzshandset.ui.weight.DialogUtils;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20001ResBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20020ResBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20034ResBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20037ResBean;
import cn.net.handsetlib.utils.ReadDeviceIDUtil;

public class LiqueurSFYSettingPresenter extends SettingConstactImpl{
	private final SettingConstact.View sView;
	private Context context;
	private List<HandsetSettingOption> beans = new ArrayList<HandsetSettingOption>();
	private ConfigBll configBll;
	private ProductBll productBll;
	private GroupInfoBll groupInfoBll;
	private DealerBll dealerBll;
	private UserLoginBll loginBll;
	private ProgressDialog bProgressDialog = null;
	private int currentHandsetVersion = HandsetVersionConstant.HANDSET_LIQUEUR_SFY_VERSION_MODE;
	private Handler mHandler = new Handler(){
		public void handleMessage(android.os.Message msg) {
			switch (msg.what) {
			case RequestConstant.REQUEST_FAIL:
				//请求失败 
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("请求失败！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT:
				//超时
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("请求超时！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PROT01_LOGIN_FAIL:
				//登录失败
				if (!checkViewAvailable())return;
				dismissProgress();
				String errorMsg = msg.obj.toString();
				int errorCode = msg.arg1;
				sView.showMsgToast(errorMsg + errorCode, Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PRODUCT_LIST_SUCCESS:
				//请求产品信息成功
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("请求产品信息成功！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PRODUCT_LIST_FAIL:
				//请求产品信息失败
				if (!checkViewAvailable())return;
				dismissProgress();
				Prot20001ResBean resBean = (Prot20001ResBean) msg.obj;
				sView.showMsgToast("请求失败 错误码：" + resBean.getErrcode(), Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PRODUCT_LIST_IS_EMPTY:
				if (!checkViewAvailable())return;
				dismissProgress();
				String errorMsg1 = msg.obj.toString();
//				int errorCode1 = msg.arg1;
				sView.showMsgToast(errorMsg1, Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_GROUP_INFO_FAIL:
				if (!checkViewAvailable())return;
				dismissProgress();
				Prot20034ResBean resBean1 = (Prot20034ResBean) msg.obj;
				sView.showMsgToast("请求失败 错误码：" + resBean1.getErrcode(), Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_GROUP_INFO_SUCCESS:
				//请求产品信息成功
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("请求班组信息成功！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_DEALERINFO_20024_NO_DATA:
				// 无用户信息
				if (!checkViewAvailable())
					return;
				dismissProgress();
				sView.showMsgToast("请求成功，但未获取到经销商信息", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_DEALERINFO_20024_FAIL:
				// 请求用户信息失败
				if (!checkViewAvailable())
					return;
				dismissProgress();
				Prot20037ResBean dealerResBean = (Prot20037ResBean) msg.obj;
				if (dealerResBean != null) {
					// res = resBean.getErrmsg()+resBean.getErrcode();
					sView.showMsgToast(
							ThreadReqTools.getErrorMsg(dealerResBean.getErrcode()) + "错误码：" + dealerResBean.getErrcode(),
							Toast.LENGTH_SHORT);
				} else {
					sView.showMsgToast("请求经销商信息失败!", Toast.LENGTH_SHORT);
				}
				break;
			case RequestConstant.PROT_REQ_DEALERINFO_20024_SUCCESS:
				// 请求用户信息成功
				if (!checkViewAvailable())
					return;
				dismissProgress();
				sView.showMsgToast("经销商信息更新成功", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_USERINFO_20020_NO_DATA:
				//无用户信息
				if (!checkViewAvailable()) return;
				dismissProgress();
				sView.showMsgToast("请求成功，但未获取到用户信息，请确认是否在后台注册过用户数据",Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_USERINFO_20020_FAIL:
				//请求用户信息失败
				if (!checkViewAvailable()) return;
				dismissProgress();
				Prot20020ResBean resBean2 = (Prot20020ResBean) msg.obj;
				if (resBean2 != null) {
//					res = resBean.getErrmsg()+resBean.getErrcode();
					sView.showMsgToast(ThreadReqTools.getErrorMsg(resBean2.getErrcode()) +"错误码："+ resBean2.getErrcode(),Toast.LENGTH_SHORT);
				} else {
					sView.showMsgToast("请求用户配置信息失败!",Toast.LENGTH_SHORT);
				}
				break;
			case RequestConstant.PROT_REQ_USERINFO_20020_SUCCESS:
				//请求用户信息成功
				if (!checkViewAvailable()) return;
				dismissProgress();
				sView.showMsgToast("用户配置信息更新成功",Toast.LENGTH_SHORT);
//				saveUserConfigUpdateDate();
				break;
			}
		};
	};
	public LiqueurSFYSettingPresenter(SettingConstact.View sView,Context context) {
		this.sView = sView;
		this.context = context;
		start();
	}

	@Override
	public void start() {
		if (!checkViewAvailable()) return;
		configBll = new ConfigBll(context);
		initSettingData();
		SettingAdapter adapter = new SettingAdapter(beans);
		sView.setAdapter(adapter);
	}

	private void initSettingData() {
		if(Config.isSpecialProt)beans.add(HandsetSettingOption.SETTING_SWITCH_PROT_TYPE_MODE);
		beans.add(HandsetSettingOption.SETTING_CONFIG_DEVICE_ID_MODE);
		beans.add(HandsetSettingOption.SETTING_UPDATE_PRODUCT_LIST_MODE);
		beans.add(HandsetSettingOption.SETTING_UPDATE_GROUP_INFO_MODE);
//		beans.add(HandsetSettingOption.SETTING_UPDATE_AGENCY_LIST_MODE);
		beans.add(HandsetSettingOption.SETTING_UPDATE_USER_CONFIG_LIST_MODE);
//		HandsetSettingOption.SETTING_UPDATE_USER_CONFIG_LIST_MODE.setSettingOptionName("更新用户信息");
		if (Config.canSwitchHandsetVersionMode) {
			beans.add(HandsetSettingOption.SETTING_HANDSET_MODE_SWITCH_MODE);
//			beans.add(new HomeBean(HandsetSettingOptionConstant.SETTING_HANDSET_MODE_SWITCH_MODE,0,"修改手持机版本模式"));
		}
	}

	@Override
	public boolean checkViewAvailable() {
		boolean b = false;
		if (sView != null && context != null) {
			b = true;
		}
		return b;
	}

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		
	}

	@Override
	public Handler getHandler() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void onItemClickListener(int position) {
		swithSettingOption(beans.get(position));
	}
	public void dismissProgress() {
		if (bProgressDialog != null) {
			try {
				DialogUtils.dismissProgressDialog(bProgressDialog);
			} catch (Exception e) {
			}
		}
	}

	/**
	 * 提示正在更新数据
	 */
	protected void showProgressDialog(String titleStr, String tipsMsg) {
		bProgressDialog = DialogUtils.showProgressDialog(bProgressDialog, titleStr,
				tipsMsg, context);
	}
	private void swithSettingOption(HandsetSettingOption setOption) {
		switch (setOption) {
		case SETTING_UPDATE_USER_CONFIG_LIST_MODE:
			//更新登陆配置
			ConfigBean userConfigBean = configBll.queryConfigByHandsetMode(currentHandsetVersion);
			if (userConfigBean != null) {
				if (!NetWorkUtils.isNetworkConnected(context)) {
					DialogUtils.showSetNetDialog(context);
					return;
				}
				showProgressDialog("提示", "正在请求用户配置信息，请稍后……");
				long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(userConfigBean.getDeviceId()));
				ThreadPoolManager.getThreadPool()
						.execute(new LiqueurSFYReqUserInfoRunable(mHandler, deviceId, getLoginBll()));
			} else {
				sView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			}
			break;
		case SETTING_SWITCH_PROT_TYPE_MODE:
			if(!checkViewAvailable()) return;
			MyHandsetApp.saveProt();
			Config.port = Config.getOfficialProt();
			sView.showMsgToast("当前网络已切换到：" + (Config.port % 100) +"号线路", Toast.LENGTH_SHORT);
			break;
		case SETTING_HANDSET_MODE_SWITCH_MODE:
			//修改手持机版本模式
			Intent modifyVersionIntent = new Intent(context, ModifyHandsetVersionActivity.class);
			context.startActivity(modifyVersionIntent);
			
			break;
		case SETTING_CONFIG_DEVICE_ID_MODE:
			//配置设备ID
//			sView.showMsgToast("配置设备ID", Toast.LENGTH_SHORT);
			Intent intent = new Intent(context, DeviceIdConfigActivity.class);
			context.startActivity(intent);
			break;
		case SETTING_UPDATE_PRODUCT_LIST_MODE:
			//更新产品列表
//			sView.showMsgToast("更新产品列表", Toast.LENGTH_SHORT);
			ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHandsetVersion);
			if (configBean != null) {
				showProgressDialog("提示", "正在请求产品信息，请稍后……");
				 long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
				 ThreadPoolManager.getThreadPool().execute(new LiqueurSFYUpdateProductListThread(mHandler,deviceId,getProductBll()));
			} else {
				sView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			}
			break;
		case SETTING_UPDATE_GROUP_INFO_MODE:
			//更新班组信息
			ConfigBean configBean1 = configBll.queryConfigByHandsetMode(currentHandsetVersion);
			if (configBean1 != null) {
				showProgressDialog("提示", "正在请求班组信息，请稍后……");
				 long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean1.getDeviceId()));
				 ThreadPoolManager.getThreadPool().execute(new LiqueurSFYUpdateGroupInfoThread(mHandler,deviceId,getGroupBll()));
			} else {
				sView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			}
			break;
		case SETTING_UPDATE_AGENCY_LIST_MODE:
			//更新经销商
			ConfigBean configBean2 = configBll.queryConfigByHandsetMode(currentHandsetVersion);
			if (configBean2 != null) {
				showProgressDialog("提示", "正在请求经销商信息，请稍后……");
				 long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean2.getDeviceId()));
				 ThreadPoolManager.getThreadPool().execute(new LiqueurSFYUpdateDealerListThread(mHandler,deviceId,getDealerBll()));
			} else {
				sView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			}
			break;
		}
	}

	private UserLoginBll getLoginBll() {
		if (loginBll == null) {
			loginBll = new UserLoginBll(context);
		}
		return loginBll;
	}

	private DealerBll getDealerBll() {
		if (dealerBll == null) {
			dealerBll = new DealerBll(context);
		}
		return dealerBll;
	}

	private GroupInfoBll getGroupBll(){
		if (groupInfoBll == null) {
			groupInfoBll = new GroupInfoBll(context);
		}
		return groupInfoBll;
	}
	private ProductBll getProductBll() {
		if (productBll == null) {
			productBll = new ProductBll(context);
		}
		return productBll;
	}

}
